<?php

function array2xml($array_item) {
    $xml = '';
    foreach($array_item as $val) {
        $xml .= '<'.constant("SUB_ELEMENT").'>';
        foreach($val as $element => $value) {
            if (is_array($value)) {
                $xml .= "<".$element.">".array2xml($value)."</".$element.">";

            }else if($value == '') {
                $xml .= "<".$element." />";
            }
            else {
                $xml .= "<".$element.">".$value."</".$element.">";
            }
        }
        $xml .= '</'.constant("SUB_ELEMENT").'>';
    }

    return '<'.constant("ROOT_ELEMENT").'>'.$xml.'</'.constant("ROOT_ELEMENT").'>';;
}
//
function XML2Array ( $xml ){

    $array = simplexml_load_string ( $xml );

    $newArray = array ( ) ;
    $array = ( array ) $array;
   // var_dump($array); exit;
    foreach($array as $arr){
    // var_dump($arr); exit;
    foreach ( $arr as $key => $value )
    {
         $newArray[]= array($key=>$value);
    }
    }
  //  $newArray = array_map("trim", $newArray);

  return $newArray ;
}

function xml_to_array($xml) {
    $xmlary = array();

    $reels = '/<(\w+)\s*([^\/>]*)\s*(?:\/>|>(.*)<\/\s*\\1\s*>)/s';
    $reattrs = '/(\w+)=(?:"|\')([^"\']*)(:?"|\')/';

    preg_match_all($reels, $xml, $elements);

    foreach ($elements[1] as $ie => $xx) {
        $xmlary[$ie]["name"] = $elements[1][$ie];

        if ($attributes == trim($elements[2][$ie])) {
            preg_match_all($reattrs, $attributes, $att);
            foreach ($att[1] as $ia => $xx)
                $xmlary[$ie]["attributes"][$att[1][$ia]] = $att[2][$ia];
        }

        $cdend = strpos($elements[3][$ie], "<");
        if ($cdend > 0) {
            $xmlary[$ie]["text"] = substr($elements[3][$ie], 0, $cdend - 1);
        }

        if (preg_match($reels, $elements[3][$ie]))
            $xmlary[$ie]["elements"] = xml_to_array($elements[3][$ie]);
        else if ($elements[3][$ie]) {
            $xmlary[$ie]["text"] = $elements[3][$ie];
        }
    }

    return $xmlary;
}


function xmlstr_to_array($xmlstr) {

    $doc = new DOMDocument();
    $doc->loadXML($xmlstr);
    return domnode_to_array($doc->documentElement);
}
function domnode_to_array($node) {

    $output = array();
    switch ($node->nodeType) {
        case XML_CDATA_SECTION_NODE:
        case XML_TEXT_NODE:
            $output = trim($node->textContent);
            break;
        case XML_ELEMENT_NODE:
            for ($i=0, $m=$node->childNodes->length; $i<$m; $i++) {
                $child = $node->childNodes->item($i);
                $v = domnode_to_array($child);
                if(isset($child->tagName)) {
                    $t = $child->tagName;
                    if(!isset($output[$t])) {
                        $output[$t] = array();
                    }
                    $output[$t][] = $v;
                }
                elseif($v) {
                    $output = (string) $v;
                }
            }
            if(is_array($output)) {
                if($node->attributes->length) {
                    $a = array();
                    foreach($node->attributes as $attrName => $attrNode) {
                        $a[$attrName] = (string) $attrNode->value;
                    }
                    $output['@attributes'] = $a;
                }
                foreach ($output as $t => $v) {
                    if(is_array($v) && count($v)==1 && $t!='@attributes') {
                        $output[$t] = $v[0];
                    }
                }
            }
            break;
    }
    return $output;
}

function xmlToArray($xml,$ns=null) {
  
    $a = array();
    for($xml->rewind(); $xml->valid(); $xml->next()) {
        $key = $xml->key();
        if(!isset($a[$key])) {
            $a[$key] = array();
            $i=0;
        }
        else $i = count($a[$key]);
        $simple = true;
        foreach($xml->current()->attributes() as $k=>$v) {
            $a[$key][$i][$k]=(string)$v;
            $simple = false;
        }
        if($ns) foreach($ns as $nid=>$name) {
                foreach($xml->current()->attributes($name) as $k=>$v) {
                    $a[$key][$i][$nid.':'.$k]=(string)$v;
                    $simple = false;
                }
            }
        if($xml->hasChildren()) {
            if($simple) $a[$key][$i] = xmlToArray($xml->current(), $ns);
            else $a[$key][$i]['content'] = xmlToArray($xml->current(), $ns);
        } else {
            if($simple) $a[$key][$i] = strval($xml->current());
            else $a[$key][$i]['content'] = strval($xml->current());
        }
        $i++;
    }
    return $a;
}
?>