<?php
/*
 Class Name : PHP-mssql Class
 Author : Henry Chen
 Last Mofidy Date : 2003-05-03
 License : GPL
 Contact Info
 	E-Mail : henryi@wowphp.net
 	ICQ : 55490755
 	AIM : wowphp
 	YIM : henryi_chen@yahoo.com

 Function List
 	1.connection	 -->	function connection()
 	2.disconnect	 -->	function disconnect()
 	3.insert		 -->	function insert($tb_name,$cols,$val,$astriction)
 	4.update		 -->	function update($tb_name,$string,$astriction)
 	5.delete		 -->	function del($tb_name,$astriction)
 	6.query			 -->	function query($string)
 	7.num_rows		 -->	function nums($string="",$qid="")
 	8.object		 -->	function objects($string="",$qid="")
 	9.insert_id		 -->	function insert_id($qid="")
 	10.pagecut		 -->	function page_cut($string,$nowpage = "0")
 	11.show_page_cut -->	function show_page_cut($string="",$num="",$url="")

 About this changing
	1. Add error handling
	2. Modifing the new code format
	3. More useful page cut function
	4. Add the function about getting the ID generated from the previous INSERT operation 

 Change Log
--------------------
  2002-07-24
--------------------
 1. Correct page_cut error. 
 2. Improve the function nums and function objects these two functions. 
 3. The new pgae_cut and show_page_cut functions can let you use these functions 
    with your template 

*/

class mod_db {
    var $setting_file = "";

    var $db_host;

    var $sql_link;
    var $db_link;
    var $query_id;
    var $perpage;
    var $total;
    var $pagecut_query;
    var $debug = "0"; // If your code can't work well just change it to 1, you can see the sql string.

    function connection() {
        // Check if SQL is connect or not
        if(!$this->sql_link) {
            // Define SQL Variables
            if(!$this->db_host || !$this->db_name || !$this->db_user || !$this->db_pass) {
                //include_once("$this->setting_file");
                global $sql_host,$sql_name,$sql_user,$sql_pass,$per_page;
                $this->db_host = $sql_host;
                $this->db_name = $sql_name;
                $this->db_user = $sql_user;
                $this->db_pass = $sql_pass;
                // Define other variables
                $this->perpage=$per_page;
            }
            // SQL Connection
            $this->sql_link = mssql_connect($this->db_host,$this->db_user,$this->db_pass);
            //var_dump($this->sql_link); exit;
            if(!$this->sql_link) {
                echo "Connect to mssql Server Error";
            }

            if($this->debug == 1) {
                echo "Connect to mssql Server Success<br>ServerHost=$this->db_host<br>";//for testing
            }

            // Select Database
            $this->db_link = mssql_select_db($this->db_name);
            if(!$this->db_link) {
                echo "Connect to DB Error , DBName = $this->db_name";
            }

            if($this->debug == 1) {
                echo "Connect to mssql DB:$this->db_name Success<br>";
            }
            return;
        }else {
            exit;
        }
    }

    function disconnect() {
        mssql_close($this->sql_link);
    }

    function insert($tb_name,$cols,$val,$astriction) {

        $arr_null = array('\'NULL\'','\'null\'');
        $val = str_replace($arr_null,'NULL',$val);
        
        if(empty($this->sql_link)) {
            $this->connection();
        }

        // Check cols is empty or not
        if(!$cols) {
            $cols = "";
        }elseif($cols != "") {
            $cols = "(".$cols.")";
        }

        // Check astriction is empty or not
        if(!$astriction) {
            $ast = "";
        }elseif($astriction != "") {
            $ast = " WHERE ".$astriction;
        }
        //echo "INSERT INTO $tb_name $cols VALUES($val) $ast",$this->sql_link; exit;

        //echo "INSERT INTO $tb_name $cols VALUES($val) $ast"; exit;


        
        $insert = mssql_query("INSERT INTO $tb_name $cols VALUES($val) $ast",$this->sql_link);
        if(!$insert) {
            echo "INSERT INTO $tb_name $cols VALUES($val) $ast"; exit;
            echo "<script>alert('Insert Data Error');</script>"; // English Error Message
            return;


        }
        if($this->debug == 1) {
            echo "Insert String = Insert into $tb_name $cols Values($val) $ast<br>";
            return;
        }

        $str_insert_id = "SELECT @@IDENTITY AS 'Identity'";
        $res_insert_id = $this->selectOne($str_insert_id);
        return $res_insert_id['Identity'];
    }

    function update($tb_name,$string,$astriction) {
        if(empty($this->sql_link)) {
            $this->connection();
        }

        // Check astriction is empty or not
        if(!$astriction) {
            $ast = "";
        }elseif($astriction != "") {
            $ast = " WHERE ".$astriction;
        }
        //echo "UPDATE $tb_name SET $string $ast"; exit;
        $update = mssql_query("UPDATE $tb_name SET $string $ast",$this->sql_link);

        if(!$update) {
            echo "'<script>alert('Update Data Error');</script>"; // English Error Message         

        }
        if($this->debug == 1) {
            echo "Update String = Update $tb_name Set $string $ast<br>";
        }
    }


    function query_update($table, $data, $where='1') {
        $q="UPDATE ".$table." SET ";

        foreach($data as $key=>$val) {
            if(strtolower($val)=="null") $q.= "$key = NULL, ";
            elseif(strtolower($val)=='now()') $q.= " $key  = GETDATE(), ";
            elseif(preg_match("/^increment\((\-?\d+)\)$/i",$val,$m)) $q.= "`$key` = `$key` + $m[1], ";
            else $q.= " $key ='".addSlashesForDB($val)."', ";
        }

        $q = rtrim($q, ', ') . ' WHERE '.$where.';';
       echo $q; exit;
        //return $q;

        return $this->query($q);
    }
    

    function del($tb_name,$astriction) {
        if(empty($this->sql_link)) {
            $this->connection();
        }

        // Check astriction is empty or not
        if(!$astriction) {
            $ast = "";
        }elseif($astriction != "") {
            $ast = " WHERE ".$astriction;
        }
        $del = mssql_query("DELETE FROM $tb_name $ast",$this->sql_link);

        if(!$del) {
            echo "<script>alert('Delete Data Error');</script>"; // English Error Message


        }
        if($this->debug == 1) {
            echo "Delete String = Delete From $tb_name $ast<br>";
        }
    }

    function query($string) {
        
        if(empty($this->sql_link)) {
            $this->connection();
        }
        //echo $string;
        $this->query_id = mssql_query($string,$this->sql_link);

        if(!$this->query_id) {
            echo $string; //exit;
            //echo "<script>alert('Unable to Perform the query:$string');</script>"; // English Error Message
            echo mssql_get_last_message(); exit;

        }
        if($this->debug == 1) {
            echo "Query String = $string <br>";
        }
        return $this->query_id;

    }

    function nums($string="",$qid="") {
        if($string != "") {
            $this->query($string);
            $this->total = mssql_num_rows($this->query_id);
        }elseif($qid != "") {
            $this->total = mssql_num_rows($qid);
        }elseif(empty($sting) && empty($qid)) {
            $this->total = mssql_num_rows($this->query_id);
        }
        if($this->debug == 1) {
            echo "Number = ".$this->total."<br>";
        }
        return $this->total;
    }

    function objects($string="",$qid="") {
        if($string != "") {
            $this->query($string);
            $objects = mssql_fetch_object($this->query_id);
            if($this->debug == 1) {
                echo "qid = ".$qid."<br>";
                echo "obj = ".$objects."<br><br>";
            }
        }elseif($qid != "") {
            $objects = mssql_fetch_object($qid);
            if($this->debug == 1) {
                echo "qid = ".$qid."<br>";
                echo "obj = ".$objects."<br><br>";
            }
        }elseif(empty($string) && empty($qid)) {
            $objects = mssql_fetch_object($this->query_id);
            if($this->debug == 1) {
                echo "qid = ".$qid."<br>";
                echo "obj = ".$objects."<br><br>";
            }
        }
        return $objects;
    }


    function selectOne($string){

        $result = array();
        
        $this->query($string);

        if($this->debug == 1) {
               // echo "qid = ".$qid."<br>";
                //echo "obj = ".$objects."<br><br>";
        }
        while($row = mssql_fetch_assoc($this->query_id)) {
            $result = $row;
        }
        if(count($result) > 0)
            return $result;
        else
            return false;

    }
    
    function selectAll($string){        
        
        $result = array();
        $this->query($string);

        if($this->debug == 1) {
                echo "qid = ".$qid."<br>";
                echo "obj = ".$objects."<br><br>";
        }
        while($row = mssql_fetch_assoc($this->query_id)) {
            //echo 'here'; exit;
            //var_dump($row); exit;
            $result[] = $row;
        }
        //var_dump($result); exit;
        return $result;
    }

    function insert_id($qid="") {
        if($qid) {
            $insert_id = mssql_insert_id($qid);
        }elseif(!$qid) {
            $insert_id = mssql_insert_id();
        }

        if($this->debug == 1) {
            echo "Insert ID = ".$insert_id."<br>";
        }
        return $insert_id;
    }



    function limitQuery($query,$order_by_field,$start,$end){
       // echo $order_by_field; exit;
       
        //$new_order_field = str_replace("SELECT ", 'SELECT row_number() over('.$order_by_field.') Sira,', $query);
        
        $new_order_field = preg_replace('/SELECT/', 'SELECT row_number() over('.$order_by_field.') Sira,', $query, 1);

        //exit;
        $string = 'SELECT * FROM (
               '.$new_order_field.'
                ) hede
                where Sira <= '.$end.' and Sira >= '.$start;
        
         //echo $string;
         
         if(empty($this->sql_link)) {
            $this->connection();
        }
        $this->query_id = mssql_query($string,$this->sql_link);

        if(!$this->query_id) {
            echo "<script>alert('Unable to Perform the query:$string');</script>"; // English Error Message
        }
        if($this->debug == 1) {
            echo "Query String = $string <br>";
        }

        $res = $this->selectAll($string);
        return $res;

    }
    

   /* function limitQuery($table,$where,$order_by_field,$start,$end){
        $str = 'SELECT * FROM (
                SELECT row_number() over('.$order_by_field.') Sira,*
                FROM '.$table.'  '.$where.'
                ) hede
                where Sira < '.$end.' and Sira > '.$start;
        $this->query($str);
       // return $str;

    }*/
}
?>
